
#include "stdafx.h"
#include <iostream>
#include <conio.h>

//define this to use TRACE macro
#define _AFXDLL
//contains TRACE macro
#include <afx.h>
#include <boost/unordered_set.hpp>

struct hasher
{  
   unsigned long operator()
   (const int& x) const
   {return (unsigned long) (x * x);}
};

int _tmain()
{
   boost::unordered_set<int,hasher,std::equal_to<int> > set1;
   int nArr[100000];

   int nIndex = 0;
   clock_t cStart, cFinish;
   cStart = clock();
   for ( ; nIndex < 25000; ++nIndex)
   {
      nArr[nIndex] = nIndex;
      set1.insert(nArr[nIndex]);
   }
   cFinish = clock();
   double dDuration = cFinish - cStart;
   std::cout << "Time for inserting 1-25000 elements: " << dDuration << "\n\n";

   cStart = clock();
   for ( nIndex = 25000; nIndex < 50000; ++nIndex)
   {
      nArr[nIndex] = nIndex;
      set1.insert(nArr[nIndex]);
   }
   cFinish = clock();
   dDuration = cFinish - cStart;
   std::cout << "Time for inserting 25001-50000 elements: " << dDuration << "\n\n";

   cStart = clock();
   for ( nIndex = 50000; nIndex < 75000; ++nIndex)
   {
      nArr[nIndex] = nIndex;
      set1.insert(nArr[nIndex]);
   }
   cFinish = clock();
   dDuration = cFinish - cStart;
   std::cout << "Time for inserting 50001-75000 elements: " << dDuration << "\n\n";

   cStart = clock();
   for ( nIndex = 75000; nIndex < 100000; ++nIndex)
   {
      nArr[nIndex] = nIndex;
      set1.insert(nArr[nIndex]);
   }
   cFinish = clock();
   dDuration = cFinish - cStart;
   std::cout << "Time for inserting 75001-100000 elements: " << dDuration << "\n\n";

   std::cout << "Press any key to continue" << "\n";
   _getch();
   return 0;
}